#if !defined(EmacsEditH)
#define EmacsEditH

#include <ShareMem.hpp>
#include <exptintf.hpp>
#include <ToolIntf.hpp>

class TEmacsEdit;
class EmacsClientRead;

class DELPHICLASS TEmacsModuleNotifier;
class TEmacsModuleNotifier : public TIModuleNotifier
{ 
	typedef Virtintf::TInterface inherited;

private:
	AnsiString filename;  

public:
	__fastcall TEmacsModuleNotifier() {};
	__fastcall ~TEmacsModuleNotifier() {};

	void SetFileName( AnsiString FileName ) { filename = FileName; filename.Unique(); }  
	void __stdcall Notify( TNotifyCode nc );
	void __stdcall ComponentRenamed(void * ComponentHandle,
																	const System::AnsiString OldName,
																	const System::AnsiString NewName) {};
};

class DELPHICLASS TEmacsNotifier;
class TEmacsNotifier : public TIAddInNotifier
{
	typedef TIExpert inherited;
private:
	TEmacsEdit* emacs;
	bool projectOpening;
	
public:
	__fastcall TEmacsNotifier() {};
	__fastcall ~TEmacsNotifier() {};
	void SetEditor( TEmacsEdit* Emacs ) { emacs = Emacs; };
	void __stdcall FileNotification(TFileNotification NotifyCode,
																	const System::AnsiString FileName,
																	bool &Cancel);
	
	void __stdcall EventNotification(TEventNotification NotifyCode,
		bool &Cancel) { return; }
};
	
class DELPHICLASS TEmacsEdit;
class TEmacsEdit : public TIExpert
{
	typedef TIExpert inherited;
private:
	TEmacsNotifier* emacsNotifier;
	EmacsClientRead* emacsReader;

	// For talking to emacs
	DWORD clientID;								// My process ID
	HANDLE serverSlot;						// Where server is listening
	HANDLE clientMailSlot;				// Where we send commands

public:
	TEmacsEdit();
	__fastcall	~TEmacsEdit();

	// For TIExpert interface
	AnsiString __stdcall GetName(void) { return "EmacsEdit"; }
	AnsiString __stdcall GetAuthor(void) { return "Jonathan Arnold"; }
	AnsiString __stdcall GetComment(void) { return "GNU Emacs interface"; }
	AnsiString __stdcall GetPage(void) { return ""; }
	HICON __stdcall GetGlyph(void) { return 0; }
	TExpertStyle __stdcall GetStyle(void) { return esAddIn; }
	TExpertState __stdcall GetState(void) { return TExpertState()<<esEnabled; }
	System::AnsiString __stdcall GetIDString(void) { return "EmacsEdit.Edit"; }
	System::AnsiString __stdcall GetMenuText(void) { return 0; }
	void __stdcall Execute(void) { return; }

	void OpenFile( AnsiString fname );
	void EmacsSend( AnsiString command );
	bool SendString( AnsiString msg );
	bool IsValid();
	void MsgFromEmacs( char* msg );
};

#endif



